function [anew,t]=bernsteintrue(a,d)

%This code insures the Bernstein copula of order d with coefficients a is
%well-defined

%input:
%a=parameters of the copula
%d=order of the copula

%output:
%pdec=parameters for well-defined copula
%t=1 if required correction

A=zeros(d+1,d+1);
A(end,:)=linspace(0,1,d+1);
A(:,end)=A(end,:)';
A(2:end-1,2:end-1)=reshape(a,d-1,d-1);
B=zeros(d+1,d+1);
B(1:end-1,1:end-1)=A(2:end,2:end)+A(1:end-1,1:end-1)-A(2:end,1:end-1)-A(1:end-1,2:end);

Amin=zeros(d+1,d+1);
Amin(end,:)=linspace(0,1,d+1);
Amin(:,end)=Amin(end,:)';
Amin(2:end-1,2:end-1)=0;
grid=linspace(0,1,d+1);
Amax=min(grid,grid');

if min(min(B))<0
    t=0;
elseif min(min(A<Amin))==1
    t=0;
elseif max(max(A>Amax))==1
    t=0;
else
    t=1;
end

if t==0
    A=min(max(A,Amin),Amax);
    for i1=2:1:d
        for i2=2:1:d
            A(i1,i2)=max([A(1:i1,i2);A(i1,1:i2)']);
        end
    end
    B=zeros(d+1,d+1);
    B(1:end-1,1:end-1)=A(2:end,2:end)+A(1:end-1,1:end-1)-A(2:end,1:end-1)-A(1:end-1,2:end);
    for i1=0:1:d-2
        for i2=0:1:d-2
            if B(d-i1,d-i2)<0
                A(d-i1,d-i2)=A(d-i1,d-i2)-B(d-i1,d-i2);
                B(d-i1-1:d-i1,d-i2-1:d-i2)=B(d-i1-1:d-i1,d-i2-1:d-i2)+B(d-i1,d-i2)*[-1,1;1,-1];
            end
        end
    end
    anew=reshape(A(2:end-1,2:end-1),(d-1)^2,1);
else
    anew=a;
end    