clear
clc

load dataeur.mat

maxit=50;
tol=10^-3;
R=20;
[u,wu]=GaussHermite_2(R);
family1='Clayton';
family2='Frank';
family3='Gaussian';
epsilon1='logit';
epsilon2='probit';
N1=50;
N2=50;
sizetest=.05;%Size of test
d=[2,3,4];%Bernstein polynomial order
nsp=10;%Number of groups for cross-validation

y0=(basicact==1);%Outcome: 1(if individual i works at period t)
x0=[(sex==2),(child_yo>=1),(child_yo>=1 & sex==2),(year-yob),(educ==3)+(educ==4),(educ==5)+(educ==6),(rental+inter)/1000];%Regressors
K=size(x0,2);%Number of regressors
Kv=3;%Number of time-variant regressors (for CRE)
T=4;%Number of time periods

country=cellstr(country);
[countries,~,idcount]=unique(country);%Country identifier
ncount=length(countries);%Number of countries

%Predefine matrices to store results
Ncount=zeros(ncount,1);
xdif=zeros(6,2*ncount);
betahatre1=zeros(T+K+1,2*ncount);
betahatre2=zeros(T+K+1,2*ncount);
betahatcre1=zeros(T+K+Kv+1,2*ncount);
betahatcre2=zeros(T+K+Kv+1,2*ncount);
betahatcbrep=zeros(T+K+2,2*ncount);
betahatcbrep1=zeros(T+K+2,2*ncount);
betahatcbrep2=zeros(T+K+2,2*ncount);
betahatcbrep3=zeros(T+K+2,2*ncount);
betahatcbrep4=zeros(T+K+2,2*ncount);
betahatcbrep5=zeros(T+K+2,2*ncount);
betahatcbrep6=zeros(T+K+2,2*ncount);
betahatcbcrep=zeros(T+K+Kv+2,2*ncount);
betahatcbcrep1=zeros(T+K+Kv+2,2*ncount);
betahatcbcrep2=zeros(T+K+Kv+2,2*ncount);
betahatcbcrep3=zeros(T+K+Kv+2,2*ncount);
betahatcbcrep4=zeros(T+K+Kv+2,2*ncount);
betahatcbcrep5=zeros(T+K+Kv+2,2*ncount);
betahatcbcrep6=zeros(T+K+Kv+2,2*ncount);
betahatcbreb=zeros(T+K+1,2*ncount);
betahatcbreb1=zeros(T+K+1,2*ncount);
betahatcbreb2=zeros(T+K+1,2*ncount);
betahatcbreb3=zeros(T+K+1,2*ncount);
betahatcbreb4=zeros(T+K+1,2*ncount);
betahatcbreb5=zeros(T+K+1,2*ncount);
betahatcbreb6=zeros(T+K+1,2*ncount);
betahatcbcreb=zeros(T+K+Kv+1,2*ncount);
betahatcbcreb1=zeros(T+K+Kv+1,2*ncount);
betahatcbcreb2=zeros(T+K+Kv+1,2*ncount);
betahatcbcreb3=zeros(T+K+Kv+1,2*ncount);
betahatcbcreb4=zeros(T+K+Kv+1,2*ncount);
betahatcbcreb5=zeros(T+K+Kv+1,2*ncount);
betahatcbcreb6=zeros(T+K+Kv+1,2*ncount);
alphahatcbreb=zeros(9,2*ncount);
alphahatcbreb1=zeros((d(1)-1)^2,2*ncount);
alphahatcbreb2=zeros((d(2)-1)^2,2*ncount);
alphahatcbreb3=zeros((d(3)-1)^2,2*ncount);
alphahatcbreb4=zeros((d(1)-1)^2,2*ncount);
alphahatcbreb5=zeros((d(2)-1)^2,2*ncount);
alphahatcbreb6=zeros((d(3)-1)^2,2*ncount);
alphahatcbcreb=zeros(9,2*ncount);
alphahatcbcreb1=zeros((d(1)-1)^2,2*ncount);
alphahatcbcreb2=zeros((d(2)-1)^2,2*ncount);
alphahatcbcreb3=zeros((d(3)-1)^2,2*ncount);
alphahatcbcreb4=zeros((d(1)-1)^2,2*ncount);
alphahatcbcreb5=zeros((d(2)-1)^2,2*ncount);
alphahatcbcreb6=zeros((d(3)-1)^2,2*ncount);
Htre1=zeros(T+K+1,T+K+1,ncount);
Htre2=zeros(T+K+1,T+K+1,ncount);
Htcre1=zeros(T+K+Kv+1,T+K+Kv+1,ncount);
Htcre2=zeros(T+K+Kv+1,T+K+Kv+1,ncount);
Htcbrep1=zeros(T+K+2,T+K+2,ncount);
Htcbrep2=zeros(T+K+2,T+K+2,ncount);
Htcbrep3=zeros(T+K+2,T+K+2,ncount);
Htcbrep4=zeros(T+K+2,T+K+2,ncount);
Htcbrep5=zeros(T+K+2,T+K+2,ncount);
Htcbrep6=zeros(T+K+2,T+K+2,ncount);
Htcbcrep1=zeros(T+K+Kv+2,T+K+Kv+2,ncount);
Htcbcrep2=zeros(T+K+Kv+2,T+K+Kv+2,ncount);
Htcbcrep3=zeros(T+K+Kv+2,T+K+Kv+2,ncount);
Htcbcrep4=zeros(T+K+Kv+2,T+K+Kv+2,ncount);
Htcbcrep5=zeros(T+K+Kv+2,T+K+Kv+2,ncount);
Htcbcrep6=zeros(T+K+Kv+2,T+K+Kv+2,ncount);
Htcbreb1=zeros(T+K+1+(d(1)-1)^2,T+K+1+(d(1)-1)^2,ncount);
Htcbreb2=zeros(T+K+1+(d(2)-1)^2,T+K+1+(d(2)-1)^2,ncount);
Htcbreb3=zeros(T+K+1+(d(3)-1)^2,T+K+1+(d(3)-1)^2,ncount);
Htcbreb4=zeros(T+K+1+(d(1)-1)^2,T+K+1+(d(1)-1)^2,ncount);
Htcbreb5=zeros(T+K+1+(d(2)-1)^2,T+K+1+(d(2)-1)^2,ncount);
Htcbreb6=zeros(T+K+1+(d(3)-1)^2,T+K+1+(d(3)-1)^2,ncount);
Htcbcreb1=zeros(T+K+Kv+1+(d(1)-1)^2,T+K+Kv+1+(d(1)-1)^2,ncount);
Htcbcreb2=zeros(T+K+Kv+1+(d(2)-1)^2,T+K+Kv+1+(d(2)-1)^2,ncount);
Htcbcreb3=zeros(T+K+Kv+1+(d(3)-1)^2,T+K+Kv+1+(d(3)-1)^2,ncount);
Htcbcreb4=zeros(T+K+Kv+1+(d(1)-1)^2,T+K+Kv+1+(d(1)-1)^2,ncount);
Htcbcreb5=zeros(T+K+Kv+1+(d(2)-1)^2,T+K+Kv+1+(d(2)-1)^2,ncount);
Htcbcreb6=zeros(T+K+Kv+1+(d(3)-1)^2,T+K+Kv+1+(d(3)-1)^2,ncount);
ll=zeros(28,ncount);
aic=zeros(28,ncount);
bic=zeros(28,ncount);
cv=zeros(28,ncount);
bestll=zeros(1,ncount);
bestaic=zeros(1,ncount);
bestbic=zeros(1,ncount);
bestcvll=zeros(1,ncount);
bestaicre=zeros(1,ncount);
bestaiccbrep=zeros(1,ncount);
bestaiccbreb=zeros(1,ncount);
bestaiccre=zeros(1,ncount);
bestaiccbcrep=zeros(1,ncount);
bestaiccbcreb=zeros(1,ncount);
dstarcbreb=zeros(1,ncount);
dstarcbcreb=zeros(1,ncount);
kendalls=zeros(24,ncount);
kendallcbrep=zeros(1,ncount);
kendallcbcrep=zeros(1,ncount);
kendallcbreb=zeros(1,ncount);
kendallcbcreb=zeros(1,ncount);
critindcbrep=zeros(1,ncount);
indtestcbrep=zeros(1,ncount);
swtestcbrep=zeros(6,ncount);
critindcbcrep=zeros(1,ncount);
indtestcbcrep=zeros(1,ncount);
swtestcbcrep=zeros(6,ncount);
ppcbrep=zeros(3,2*ncount);
ppcbcrep=zeros(3,2*ncount);
ppcbreb=zeros(3,2*ncount);
ppcbcreb=zeros(3,2*ncount);
absprob=zeros(2,ncount);
pdeccbrep=zeros(9,2*ncount);
pdeccbcrep=zeros(9,2*ncount);
pdeccbreb=zeros(9,2*ncount);
pdeccbcreb=zeros(9,2*ncount);
for i1=1:1:ncount
    %Select data country i1
    id=find(idcount==i1);
    Ncount(i1)=length(id);
    y=y0(id);
    x=x0(id,:);
    N=size(y,1)/T;
    y=[y(1:N,1),y(N+1:2*N,1),y(2*N+1:3*N,1),y(3*N+1:4*N,1)];
    x=[x(1:N,:),x(N+1:2*N,:),x(2*N+1:3*N,:),x(3*N+1:4*N,:)];
    xm=(x(:,[2,3,7])+x(:,[9,10,14])+x(:,[16,17,21])+x(:,[23,24,28]))/4;
    nc=2*ones(N/2,1);
    cumnc=[0;cumsum(nc)];
    
    %Difference in covariates for wives whose husbands are employed vs
    %unemployed
    xcond=zeros(2,6);
    xvar=zeros(2,6);
    ncond=zeros(2,1);
    for i2=1:1:length(nc)
        for i3=1:1:T
            if y(2*(i2-1)+1,i3)==1
                xcond(1,:)=xcond(1,:)+x(2*i2,7*(i3-1)+2:7*i3);
                ncond(1)=ncond(1)+1;
            elseif y(2*(i2-1)+1,i3)==0
                xcond(2,:)=xcond(2,:)+x(2*i2,7*(i3-1)+2:7*i3);
                ncond(2)=ncond(2)+1;
            end
        end
    end
    xdif(:,2*(i1-1)+1)=xcond(1,:)'/ncond(1)-xcond(2,:)'/ncond(2);
    for i2=1:1:length(nc)
        for i3=1:1:T
            if y(2*(i2-1)+1,i3)==1
                xvar(1,:)=xvar(1,:)+(x(2*i2,7*(i3-1)+2:7*i3)-xcond(1,:)/ncond(1)).^2/ncond(1)^2;
            elseif y(2*(i2-1)+1,i3)==0
                xvar(2,:)=xvar(2,:)+(x(2*i2,7*(i3-1)+2:7*i3)-xcond(2,:)/ncond(2)).^2/ncond(2)^2;
            end
        end
    end
    xdif(:,2*i1)=sum(sqrt(xvar),1)';
    
    %Logit RE estimates
    beta0=[zeros(T+K,1);1];%Initial value of the parameters for the RE estimator
    [b,~,ll(1,i1)]=bc_re(y,x,beta0,R,maxit,tol,epsilon1);
    Htre1(:,:,i1)=bc_re_var(y,x,nc,beta0,R,epsilon1);
    betahatre1(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htre1(:,:,i1)))];
    %Probit RE estimates
    [b,~,ll(2,i1)]=bc_re(y,x,beta0,R,maxit,tol,epsilon2);
    Htre2(:,:,i1)=bc_re_var(y,x,nc,beta0,R,epsilon2);
    betahatre2(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htre2(:,:,i1)))];
    
    %Logit CRE estimates
    beta0=[betahatre1(1:T+K,2*(i1-1)+1);zeros(Kv,1);betahatre1(end,2*(i1-1)+1)];
    [b,~,ll(3,i1)]=bc_cre(y,x,xm,beta0,R,maxit,tol,epsilon1);
    Htcre1(:,:,i1)=bc_cre_var(y,x,xm,nc,beta0,R,epsilon1);
    betahatcre1(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcre1(:,:,i1)))];
    %Probit CRE estimates
    beta0=[betahatre2(1:T+K,2*(i1-1)+1);zeros(Kv,1);betahatre2(end,2*(i1-1)+1)];
    [b,~,ll(4,i1)]=bc_cre(y,x,xm,beta0,R,maxit,tol,epsilon2);
    Htcre2(:,:,i1)=bc_cre_var(y,x,xm,nc,beta0,R,epsilon2);
    betahatcre2(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcre2(:,:,i1)))];
    
    %Logit CBRE estimates with three different copulas: Clayton, Gumbel,
    %and Gaussian (use initial the RE estimates as initial values except
    %for the correlation parameter rho)
    corr0=0;
    beta0=[betahatre1(:,2*(i1-1)+1);copulaparam(family1,corr0)];
    [b,Htcbrep1(:,:,i1),ll(5,i1)]=bc_cbre(y,x,nc,beta0,maxit,tol,epsilon1,family1,N1,N2);
    Htcbrep1(:,:,i1)=inv(Htcbrep1(:,:,i1));
    betahatcbrep1(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbrep1(:,:,i1)))];
    beta0=[betahatre1(:,2*(i1-1)+1);copulaparam(family2,corr0)];
    [b,Htcbrep2(:,:,i1),ll(6,i1)]=bc_cbre(y,x,nc,beta0,maxit,tol,epsilon1,family2,N1,N2);
    Htcbrep2(:,:,i1)=inv(Htcbrep2(:,:,i1));
    betahatcbrep2(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbrep2(:,:,i1)))];
    beta0=[betahatre1(:,2*(i1-1)+1);copulaparam(family3,corr0)];
    [b,Htcbrep3(:,:,i1),ll(7,i1)]=bc_cbre(y,x,nc,beta0,maxit,tol,epsilon1,family3,N1,N2);
    Htcbrep3(:,:,i1)=inv(Htcbrep3(:,:,i1));
    betahatcbrep3(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbrep3(:,:,i1)))];
    %Probit CBRE estimates with three different copulas: Clayton, Gumbel,
    %and Gaussian (use initial the RE estimates as initial values except
    %for the correlation parameter rho)
    beta0=[betahatre2(:,2*(i1-1)+1);copulaparam(family1,corr0)];
    [b,Htcbrep4(:,:,i1),ll(8,i1)]=bc_cbre(y,x,nc,beta0,maxit,tol,epsilon2,family1,N1,N2);
    Htcbrep4(:,:,i1)=inv(Htcbrep4(:,:,i1));
    betahatcbrep4(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbrep4(:,:,i1)))];
    beta0=[betahatre2(:,2*(i1-1)+1);copulaparam(family2,corr0)];
    [b,Htcbrep5(:,:,i1),ll(9,i1)]=bc_cbre(y,x,nc,beta0,maxit,tol,epsilon2,family2,N1,N2);
    Htcbrep5(:,:,i1)=inv(Htcbrep5(:,:,i1));
    betahatcbrep5(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbrep5(:,:,i1)))];
    beta0=[betahatre2(:,2*(i1-1)+1);copulaparam(family3,corr0)];
    [b,Htcbrep6(:,:,i1),ll(10,i1)]=bc_cbre(y,x,nc,beta0,maxit,tol,epsilon2,family3,N1,N2);
    Htcbrep6(:,:,i1)=inv(Htcbrep6(:,:,i1));
    betahatcbrep6(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbrep6(:,:,i1)))];
    
    %Logit CBCRE estimates with three different copulas: Clayton, Gumbel,
    %and Gaussian (use initial the RE estimates as initial values except
    %for the correlation parameter rho)
    corr0=0;
    beta0=[betahatcre1(:,2*(i1-1)+1);copulaparam(family1,corr0)];
    [b,Htcbcrep1(:,:,i1),ll(11,i1)]=bc_cbcre(y,x,xm,nc,beta0,maxit,tol,epsilon1,family1,N1,N2);
    Htcbcrep1(:,:,i1)=inv(Htcbcrep1(:,:,i1));
    betahatcbcrep1(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbcrep1(:,:,i1)))];
    beta0=[betahatcre1(:,2*(i1-1)+1);copulaparam(family2,corr0)];
    [b,Htcbcrep2(:,:,i1),ll(12,i1)]=bc_cbcre(y,x,xm,nc,beta0,maxit,tol,epsilon1,family2,N1,N2);
    Htcbcrep2(:,:,i1)=inv(Htcbcrep2(:,:,i1));
    betahatcbcrep2(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbcrep2(:,:,i1)))];
    beta0=[betahatcre1(:,2*(i1-1)+1);copulaparam(family3,corr0)];
    [b,Htcbcrep3(:,:,i1),ll(13,i1)]=bc_cbcre(y,x,xm,nc,beta0,maxit,tol,epsilon1,family3,N1,N2);
    Htcbcrep3(:,:,i1)=inv(Htcbcrep3(:,:,i1));
    betahatcbcrep3(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbcrep3(:,:,i1)))];
    %Probit CBCRE estimates with three different copulas: Clayton, Gumbel,
    %and Gaussian (use initial the RE estimates as initial values except
    %for the correlation parameter rho)
    beta0=[betahatcre2(:,2*(i1-1)+1);copulaparam(family1,corr0)];
    [b,Htcbcrep4(:,:,i1),ll(14,i1)]=bc_cbcre(y,x,xm,nc,beta0,maxit,tol,epsilon2,family1,N1,N2);
    Htcbcrep4(:,:,i1)=inv(Htcbcrep4(:,:,i1));
    betahatcbcrep4(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbcrep4(:,:,i1)))];
    beta0=[betahatcre2(:,2*(i1-1)+1);copulaparam(family2,corr0)];
    [b,Htcbcrep5(:,:,i1),ll(15,i1)]=bc_cbcre(y,x,xm,nc,beta0,maxit,tol,epsilon2,family2,N1,N2);
    Htcbcrep5(:,:,i1)=inv(Htcbcrep5(:,:,i1));
    betahatcbcrep5(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbcrep5(:,:,i1)))];
    beta0=[betahatcre2(:,2*(i1-1)+1);copulaparam(family3,corr0)];
    [b,Htcbcrep6(:,:,i1),ll(16,i1)]=bc_cbcre(y,x,xm,nc,beta0,maxit,tol,epsilon2,family3,N1,N2);
    Htcbcrep6(:,:,i1)=inv(Htcbcrep6(:,:,i1));
    betahatcbcrep6(:,2*(i1-1)+1:2*i1)=[b,sqrt(diag(Htcbcrep6(:,:,i1)))];
    
    %Logit CBRE estimates with Bernstein copulas
    beta0=betahatre1(:,2*(i1-1)+1);
    alpha0=ones((d(1)-1)^2,1);
    [b,a,Htcbreb1(:,:,i1),ll(17,i1)]=bc_cbreb(y,x,nc,beta0,alpha0,maxit,tol,epsilon1,N1,d(1));
    Htcbreb1(:,:,i1)=inv(Htcbreb1(:,:,i1));
    se=sqrt(diag(Htcbreb1(:,:,i1)));
    betahatcbreb1(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbreb1(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    alpha0=ones((d(2)-1)^2,1);
    [b,a,Htcbreb2(:,:,i1),ll(18,i1)]=bc_cbreb(y,x,nc,beta0,alpha0,maxit,tol,epsilon1,N1,d(2));
    Htcbreb2(:,:,i1)=inv(Htcbreb2(:,:,i1));
    se=sqrt(diag(Htcbreb2(:,:,i1)));
    betahatcbreb2(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbreb2(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    alpha0=ones((d(3)-1)^2,1);
    [b,a,Htcbreb3(:,:,i1),ll(19,i1)]=bc_cbreb(y,x,nc,beta0,alpha0,maxit,tol,epsilon1,N1,d(3));
    Htcbreb3(:,:,i1)=inv(Htcbreb3(:,:,i1));
    se=sqrt(diag(Htcbreb3(:,:,i1)));
    betahatcbreb3(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbreb3(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    %Probit CBRE estimates with Bernstein copulas
    beta0=betahatre2(:,2*(i1-1)+1);
    alpha0=zeros((d(1)-1)^2,1);
    [b,a,Htcbreb4(:,:,i1),ll(20,i1)]=bc_cbreb(y,x,nc,beta0,alpha0,maxit,tol,epsilon2,N1,d(1));
    Htcbreb4(:,:,i1)=inv(Htcbreb4(:,:,i1));
    se=sqrt(diag(Htcbreb4(:,:,i1)));
    betahatcbreb4(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbreb4(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    alpha0=zeros((d(2)-1)^2,1);
    [b,a,Htcbreb5(:,:,i1),ll(21,i1)]=bc_cbreb(y,x,nc,beta0,alpha0,maxit,tol,epsilon2,N1,d(2));
    Htcbreb5(:,:,i1)=inv(Htcbreb5(:,:,i1));
    se=sqrt(diag(Htcbreb5(:,:,i1)));
    betahatcbreb5(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbreb5(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    alpha0=zeros((d(3)-1)^2,1);
    [b,a,Htcbreb6(:,:,i1),ll(22,i1)]=bc_cbreb(y,x,nc,beta0,alpha0,maxit,tol,epsilon2,N1,d(3));
    Htcbreb6(:,:,i1)=inv(Htcbreb6(:,:,i1));
    se=sqrt(diag(Htcbreb6(:,:,i1)));
    betahatcbreb6(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbreb6(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];

    %Logit CBCRE estimates with Bernstein copulas
    beta0=betahatcre1(:,2*(i1-1)+1);
    alpha0=ones((d(1)-1)^2,1);
    [b,a,Htcbcreb1(:,:,i1),ll(23,i1)]=bc_cbcreb(y,x,xm,nc,beta0,alpha0,maxit,tol,epsilon1,N1,d(1));
    Htcbcreb1(:,:,i1)=inv(Htcbcreb1(:,:,i1));
    se=sqrt(diag(Htcbcreb1(:,:,i1)));
    betahatcbcreb1(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbcreb1(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    alpha0=ones((d(2)-1)^2,1);
    [b,a,Htcbcreb2(:,:,i1),ll(24,i1)]=bc_cbcreb(y,x,xm,nc,beta0,alpha0,maxit,tol,epsilon1,N1,d(2));
    Htcbcreb2(:,:,i1)=inv(Htcbcreb2(:,:,i1));
    se=sqrt(diag(Htcbcreb2(:,:,i1)));
    betahatcbcreb2(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbcreb2(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    alpha0=ones((d(3)-1)^2,1);
    [b,a,Htcbcreb3(:,:,i1),ll(25,i1)]=bc_cbcreb(y,x,xm,nc,beta0,alpha0,maxit,tol,epsilon1,N1,d(3));
    Htcbcreb3(:,:,i1)=inv(Htcbcreb3(:,:,i1));
    se=sqrt(diag(Htcbcreb3(:,:,i1)));
    betahatcbcreb3(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbcreb3(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    %Probit CBCRE estimates with Bernstein copulas
    beta0=betahatcre2(:,2*(i1-1)+1);
    alpha0=zeros((d(1)-1)^2,1);
    [b,a,Htcbcreb4(:,:,i1),ll(26,i1)]=bc_cbcreb(y,x,xm,nc,beta0,alpha0,maxit,tol,epsilon2,N1,d(1));
    Htcbcreb4(:,:,i1)=inv(Htcbcreb4(:,:,i1));
    se=sqrt(diag(Htcbcreb4(:,:,i1)));
    betahatcbcreb4(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbcreb4(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    alpha0=zeros((d(2)-1)^2,1);
    [b,a,Htcbcreb5(:,:,i1),ll(27,i1)]=bc_cbcreb(y,x,xm,nc,beta0,alpha0,maxit,tol,epsilon2,N1,d(2));
    Htcbcreb5(:,:,i1)=inv(Htcbcreb5(:,:,i1));
    se=sqrt(diag(Htcbcreb5(:,:,i1)));
    betahatcbcreb5(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbcreb5(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    alpha0=zeros((d(3)-1)^2,1);
    [b,a,Htcbcreb6(:,:,i1),ll(28,i1)]=bc_cbcreb(y,x,xm,nc,beta0,alpha0,maxit,tol,epsilon2,N1,d(3));
    Htcbcreb6(:,:,i1)=inv(Htcbcreb6(:,:,i1));
    se=sqrt(diag(Htcbcreb6(:,:,i1)));
    betahatcbcreb6(:,2*(i1-1)+1:2*i1)=[b,se(1:length(b))];
    alphahatcbcreb6(:,2*(i1-1)+1:2*i1)=[a,se(length(b)+1:end)];
    
    %Akaike Information Criterion
    aic(1:2,i1)=2*(T+K+1-ll(1:2,i1));
    aic(3:4,i1)=2*(T+K+Kv+1-ll(3:4,i1));
    aic(5:10,i1)=2*(T+K+2-ll(5:10,i1));
    aic(11:16,i1)=2*(T+K+Kv+2-ll(11:16,i1));
    aic(17:22,i1)=2*(T+K+1+(kron([1;1],d')-1).^2-ll(17:22,i1));
    aic(23:28,i1)=2*(T+K+Kv+1+(kron([1;1],d')-1).^2-ll(23:28,i1));
    
    %Bayesian Information Criterion
    bic(1:2,i1)=log(Ncount(i1))*(T+K+1)-2*ll(1:2,i1);
    bic(3:4,i1)=log(Ncount(i1))*(T+K+Kv+1)-2*ll(3:4,i1);
    bic(5:10,i1)=log(Ncount(i1))*(T+K+2)-2*ll(5:10,i1);
    bic(11:16,i1)=log(Ncount(i1))*(T+K+Kv+2)-2*ll(11:16,i1);
    bic(17:22,i1)=log(Ncount(i1))*(T+K+(kron([1;1],d')-1).^2+1)-2*ll(17:22,i1);
    bic(23:28,i1)=log(Ncount(i1))*(T+K+Kv+(kron([1;1],d')-1).^2+1)-2*ll(23:28,i1);
    
    %Cross validation
    cvll=zeros(28,nsp);
    ind=cvpartition(N/2,'Kfold',nsp);
    for i2=1:1:nsp
        idx=training(ind,i2);
        idx2=zeros(N,1);
        for i3=1:1:N/2
            idx2(cumnc(i3)+1:cumnc(i3+1))=idx(i3);
        end
        ycv=y(idx2==1,:);
        xcv=x(idx2==1,:);
        xmcv=xm(idx2==1,:);
        nccv=nc(idx==1,:);
        ytr=y(idx2==0,:);
        xtr=x(idx2==0,:);
        xmtr=xm(idx2==0,:);
        nctr=nc(idx==0,:);
        
        %RE
        b=bc_re(ycv,xcv,betahatre1(:,2*(i1-1)+1),R,maxit,tol,epsilon1);
        cvll(1,i2)=bc_re_ll(ytr,xtr,b,u,wu,epsilon1);
        b=bc_re(ycv,xcv,betahatre2(:,2*(i1-1)+1),R,maxit,tol,epsilon2);
        cvll(2,i2)=bc_re_ll(ytr,xtr,b,u,wu,epsilon2);
        %CRE
        b=bc_cre(ycv,xcv,xmcv,betahatcre1(:,2*(i1-1)+1),R,maxit,tol,epsilon1);
        cvll(3,i2)=bc_cre_ll(ytr,xtr,xmtr,b,u,wu,epsilon1);
        b=bc_cre(ycv,xcv,xmcv,betahatcre2(:,2*(i1-1)+1),R,maxit,tol,epsilon2);
        cvll(4,i2)=bc_cre_ll(ytr,xtr,xmtr,b,u,wu,epsilon2);
        %CBRE (parametric)
        b=bc_cbre(ycv,xcv,nccv,betahatcbrep1(:,2*(i1-1)+1),maxit,tol,epsilon1,family1,N1,N2);
        cvll(5,i2)=bc_cbre_ll(ytr,xtr,nctr,b,epsilon1,family1,N1,N2);
        b=bc_cbre(ycv,xcv,nccv,betahatcbrep2(:,2*(i1-1)+1),maxit,tol,epsilon1,family2,N1,N2);
        cvll(6,i2)=bc_cbre_ll(ytr,xtr,nctr,b,epsilon1,family2,N1,N2);
        b=bc_cbre(ycv,xcv,nccv,betahatcbrep3(:,2*(i1-1)+1),maxit,tol,epsilon1,family3,N1,N2);
        cvll(7,i2)=bc_cbre_ll(ytr,xtr,nctr,b,epsilon1,family3,N1,N2);
        b=bc_cbre(ycv,xcv,nccv,betahatcbrep4(:,2*(i1-1)+1),maxit,tol,epsilon2,family1,N1,N2);
        cvll(8,i2)=bc_cbre_ll(ytr,xtr,nctr,b,epsilon2,family1,N1,N2);
        b=bc_cbre(ycv,xcv,nccv,betahatcbrep5(:,2*(i1-1)+1),maxit,tol,epsilon2,family2,N1,N2);
        cvll(9,i2)=bc_cbre_ll(ytr,xtr,nctr,b,epsilon2,family2,N1,N2);
        b=bc_cbre(ycv,xcv,nccv,betahatcbrep6(:,2*(i1-1)+1),maxit,tol,epsilon2,family3,N1,N2);
        cvll(10,i2)=bc_cbre_ll(ytr,xtr,nctr,b,epsilon2,family3,N1,N2);
        %CBCRE (parametric)
        b=bc_cbcre(ycv,xcv,xmcv,nccv,betahatcbcrep1(:,2*(i1-1)+1),maxit,tol,epsilon1,family1,N1,N2);
        cvll(11,i2)=bc_cbcre_ll(ytr,xtr,xmtr,nctr,b,epsilon1,family1,N1,N2);
        b=bc_cbcre(ycv,xcv,xmcv,nccv,betahatcbcrep2(:,2*(i1-1)+1),maxit,tol,epsilon1,family2,N1,N2);
        cvll(12,i2)=bc_cbcre_ll(ytr,xtr,xmtr,nctr,b,epsilon1,family2,N1,N2);
        b=bc_cbcre(ycv,xcv,xmcv,nccv,betahatcbcrep3(:,2*(i1-1)+1),maxit,tol,epsilon1,family3,N1,N2);
        cvll(13,i2)=bc_cbcre_ll(ytr,xtr,xmtr,nctr,b,epsilon1,family3,N1,N2);
        b=bc_cbcre(ycv,xcv,xmcv,nccv,betahatcbcrep4(:,2*(i1-1)+1),maxit,tol,epsilon2,family1,N1,N2);
        cvll(14,i2)=bc_cbcre_ll(ytr,xtr,xmtr,nctr,b,epsilon2,family1,N1,N2);
        b=bc_cbcre(ycv,xcv,xmcv,nccv,betahatcbcrep5(:,2*(i1-1)+1),maxit,tol,epsilon2,family2,N1,N2);
        cvll(15,i2)=bc_cbcre_ll(ytr,xtr,xmtr,nctr,b,epsilon2,family2,N1,N2);
        b=bc_cbcre(ycv,xcv,xmcv,nccv,betahatcbcrep6(:,2*(i1-1)+1),maxit,tol,epsilon2,family3,N1,N2);
        cvll(16,i2)=bc_cbcre_ll(ytr,xtr,xmtr,nctr,b,epsilon2,family3,N1,N2);
        %CBRE (Bernstein)
        [b,a]=bc_cbreb(ycv,xcv,nccv,betahatcbreb1(:,2*(i1-1)+1),alphahatcbreb1(:,2*(i1-1)+1),maxit,tol,epsilon1,N1,d(1));
        cvll(17,i2)=bc_cbreb_ll(ytr,xtr,nctr,b,a,epsilon1,N1,d(1));
        [b,a]=bc_cbreb(ycv,xcv,nccv,betahatcbreb2(:,2*(i1-1)+1),alphahatcbreb2(:,2*(i1-1)+1),maxit,tol,epsilon1,N1,d(2));
        cvll(18,i2)=bc_cbreb_ll(ytr,xtr,nctr,b,a,epsilon1,N1,d(2));
        [b,a]=bc_cbreb(ycv,xcv,nccv,betahatcbreb3(:,2*(i1-1)+1),alphahatcbreb3(:,2*(i1-1)+1),maxit,tol,epsilon1,N1,d(3));
        cvll(19,i2)=bc_cbreb_ll(ytr,xtr,nctr,b,a,epsilon1,N1,d(3));
        [b,a]=bc_cbreb(ycv,xcv,nccv,betahatcbreb4(:,2*(i1-1)+1),alphahatcbreb4(:,2*(i1-1)+1),maxit,tol,epsilon2,N1,d(1));
        cvll(20,i2)=bc_cbreb_ll(ytr,xtr,nctr,b,a,epsilon2,N1,d(1));
        [b,a]=bc_cbreb(ycv,xcv,nccv,betahatcbreb5(:,2*(i1-1)+1),alphahatcbreb5(:,2*(i1-1)+1),maxit,tol,epsilon2,N1,d(2));
        cvll(21,i2)=bc_cbreb_ll(ytr,xtr,nctr,b,a,epsilon2,N1,d(2));
        [b,a]=bc_cbreb(ycv,xcv,nccv,betahatcbreb6(:,2*(i1-1)+1),alphahatcbreb6(:,2*(i1-1)+1),maxit,tol,epsilon2,N1,d(3));
        cvll(22,i2)=bc_cbreb_ll(ytr,xtr,nctr,b,a,epsilon2,N1,d(3));
        %CBCRE (Bernstein)
        [b,a]=bc_cbcreb(ycv,xcv,xmcv,nccv,betahatcbcreb1(:,2*(i1-1)+1),alphahatcbcreb1(:,2*(i1-1)+1),maxit,tol,epsilon1,N1,d(1));
        cvll(23,i2)=bc_cbcreb_ll(ytr,xtr,xmtr,nctr,b,a,epsilon1,N1,d(1));
        [b,a]=bc_cbcreb(ycv,xcv,xmcv,nccv,betahatcbcreb2(:,2*(i1-1)+1),alphahatcbcreb2(:,2*(i1-1)+1),maxit,tol,epsilon1,N1,d(2));
        cvll(24,i2)=bc_cbcreb_ll(ytr,xtr,xmtr,nctr,b,a,epsilon1,N1,d(2));
        [b,a]=bc_cbcreb(ycv,xcv,xmcv,nccv,betahatcbcreb3(:,2*(i1-1)+1),alphahatcbcreb3(:,2*(i1-1)+1),maxit,tol,epsilon1,N1,d(3));
        cvll(25,i2)=bc_cbcreb_ll(ytr,xtr,xmtr,nctr,b,a,epsilon1,N1,d(3));
        [b,a]=bc_cbcreb(ycv,xcv,xmcv,nccv,betahatcbcreb4(:,2*(i1-1)+1),alphahatcbcreb4(:,2*(i1-1)+1),maxit,tol,epsilon2,N1,d(1));
        cvll(26,i2)=bc_cbcreb_ll(ytr,xtr,xmtr,nctr,b,a,epsilon2,N1,d(1));
        [b,a]=bc_cbcreb(ycv,xcv,xmcv,nccv,betahatcbcreb5(:,2*(i1-1)+1),alphahatcbcreb5(:,2*(i1-1)+1),maxit,tol,epsilon2,N1,d(2));
        cvll(27,i2)=bc_cbcreb_ll(ytr,xtr,xmtr,nctr,b,a,epsilon2,N1,d(2));
        [b,a]=bc_cbcreb(ycv,xcv,xmcv,nccv,betahatcbcreb6(:,2*(i1-1)+1),alphahatcbcreb6(:,2*(i1-1)+1),maxit,tol,epsilon2,N1,d(3));
        cvll(28,i2)=bc_cbcreb_ll(ytr,xtr,xmtr,nctr,b,a,epsilon2,N1,d(3));
    end
    cv(:,i1)=sum(cvll,2);
    
    %Find best fitting models
    [~,bestll(i1)]=max(ll(:,i1));
    [~,bestaic(i1)]=min(aic(:,i1));
    [~,bestbic(i1)]=min(bic(:,i1));
    [~,bestcvll(i1)]=max(cv(:,i1));
    
    [~,bestaicre(i1)]=min(aic(1:2,i1));
    [~,bestaiccre(i1)]=min(aic(3:4,i1));
    [~,bestaiccbrep(i1)]=min(aic(5:10,i1));
    [~,bestaiccbcrep(i1)]=min(aic(11:16,i1));
    [~,bestaiccbreb(i1)]=min(aic(17:22,i1));
    [~,bestaiccbcreb(i1)]=min(aic(23:28,i1));
    
    %Kendall statistics
    kendalls(i1,1)=copulastat(family1,betahatcbrep1(end,2*(i1-1)+1));
    kendalls(i1,2)=copulastat(family2,betahatcbrep2(end,2*(i1-1)+1));
    kendalls(i1,3)=copulastat(family3,betahatcbrep3(end,2*(i1-1)+1));
    kendalls(i1,4)=copulastat(family1,betahatcbrep4(end,2*(i1-1)+1));
    kendalls(i1,5)=copulastat(family2,betahatcbrep5(end,2*(i1-1)+1));
    kendalls(i1,6)=copulastat(family3,betahatcbrep6(end,2*(i1-1)+1));
    kendalls(i1,7)=copulastat(family1,betahatcbcrep1(end,2*(i1-1)+1));
    kendalls(i1,8)=copulastat(family2,betahatcbcrep2(end,2*(i1-1)+1));
    kendalls(i1,9)=copulastat(family3,betahatcbcrep3(end,2*(i1-1)+1));
    kendalls(i1,10)=copulastat(family1,betahatcbcrep4(end,2*(i1-1)+1));
    kendalls(i1,11)=copulastat(family2,betahatcbcrep5(end,2*(i1-1)+1));
    kendalls(i1,12)=copulastat(family3,betahatcbcrep6(end,2*(i1-1)+1));
    [C,c,~]=bernsteindens(alphahatcbreb1(:,2*(i1-1)+1),100);
    kendalls(i1,13)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbreb2(:,2*(i1-1)+1),100);
    kendalls(i1,14)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbreb3(:,2*(i1-1)+1),100);
    kendalls(i1,15)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbreb4(:,2*(i1-1)+1),100);
    kendalls(i1,16)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbreb5(:,2*(i1-1)+1),100);
    kendalls(i1,17)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbreb6(:,2*(i1-1)+1),100);
    kendalls(i1,18)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbcreb1(:,2*(i1-1)+1),100);
    kendalls(i1,19)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbcreb2(:,2*(i1-1)+1),100);
    kendalls(i1,20)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbcreb3(:,2*(i1-1)+1),100);
    kendalls(i1,21)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbcreb4(:,2*(i1-1)+1),100);
    kendalls(i1,22)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbcreb5(:,2*(i1-1)+1),100);
    kendalls(i1,23)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphahatcbcreb6(:,2*(i1-1)+1),100);
    kendalls(i1,24)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    
    if bestaiccbreb(i1)<=3
        dstarcbreb(i1)=bestaiccbreb(i1)+1;
    else
        dstarcbreb(i1)=bestaiccbreb(i1)-2;
    end
    if bestaiccbcreb(i1)<=3
        dstarcbcreb(i1)=bestaiccbcreb(i1)+1;
    else
        dstarcbcreb(i1)=bestaiccbcreb(i1)-2;
    end
    
    %Tests of hypothesis
    if bestaiccbrep(i1)==1
        [~,critindcbrep(:,i1),indtestcbrep(:,i1)]=testindcbre(family1,betahatcbrep1(:,2*(i1-1)+1),Htcbrep1(:,:,i1),sizetest);
        swtestcbrep(:,i1)=[0;
            testswcbre(y,x,nc,epsilon1,epsilon1,family1,family2,betahatcbrep1(:,2*(i1-1)+1),betahatcbrep2(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon1,epsilon1,family1,family3,betahatcbrep1(:,2*(i1-1)+1),betahatcbrep3(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon1,epsilon2,family1,family1,betahatcbrep1(:,2*(i1-1)+1),betahatcbrep4(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon1,epsilon2,family1,family2,betahatcbrep1(:,2*(i1-1)+1),betahatcbrep5(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon1,epsilon2,family1,family3,betahatcbrep1(:,2*(i1-1)+1),betahatcbrep6(:,2*(i1-1)+1),N1,N2,sizetest)];
    elseif bestaiccbrep(i1)==2
        [~,critindcbrep(:,i1),indtestcbrep(:,i1)]=testindcbre(family2,betahatcbrep2(:,2*(i1-1)+1),Htcbrep2(:,:,i1),sizetest);
        swtestcbrep(:,i1)=[testswcbre(y,x,nc,epsilon1,epsilon1,family2,family1,betahatcbrep2(:,2*(i1-1)+1),betahatcbrep1(:,2*(i1-1)+1),N1,N2,sizetest);
            0;
            testswcbre(y,x,nc,epsilon1,epsilon1,family2,family3,betahatcbrep2(:,2*(i1-1)+1),betahatcbrep3(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon1,epsilon2,family2,family1,betahatcbrep2(:,2*(i1-1)+1),betahatcbrep4(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon1,epsilon2,family2,family2,betahatcbrep2(:,2*(i1-1)+1),betahatcbrep5(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon1,epsilon2,family2,family3,betahatcbrep2(:,2*(i1-1)+1),betahatcbrep6(:,2*(i1-1)+1),N1,N2,sizetest)];
    elseif bestaiccbrep(i1)==3
        [~,critindcbrep(:,i1),indtestcbrep(:,i1)]=testindcbre(family3,betahatcbrep3(:,2*(i1-1)+1),Htcbrep3(:,:,i1),sizetest);
        swtestcbrep(:,i1)=[testswcbre(y,x,nc,epsilon1,epsilon1,family3,family1,betahatcbrep3(:,2*(i1-1)+1),betahatcbrep1(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon1,epsilon1,family3,family2,betahatcbrep3(:,2*(i1-1)+1),betahatcbrep2(:,2*(i1-1)+1),N1,N2,sizetest);
            0;
            testswcbre(y,x,nc,epsilon1,epsilon2,family3,family1,betahatcbrep3(:,2*(i1-1)+1),betahatcbrep4(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon1,epsilon2,family3,family2,betahatcbrep3(:,2*(i1-1)+1),betahatcbrep5(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon1,epsilon2,family3,family3,betahatcbrep3(:,2*(i1-1)+1),betahatcbrep6(:,2*(i1-1)+1),N1,N2,sizetest)];
    elseif bestaiccbrep(i1)==4
        [~,critindcbrep(:,i1),indtestcbrep(:,i1)]=testindcbre(family1,betahatcbrep4(:,2*(i1-1)+1),Htcbrep4(:,:,i1),sizetest);
        swtestcbrep(:,i1)=[testswcbre(y,x,nc,epsilon2,epsilon1,family1,family1,betahatcbrep4(:,2*(i1-1)+1),betahatcbrep1(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon2,epsilon1,family1,family2,betahatcbrep4(:,2*(i1-1)+1),betahatcbrep2(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon2,epsilon1,family1,family3,betahatcbrep4(:,2*(i1-1)+1),betahatcbrep3(:,2*(i1-1)+1),N1,N2,sizetest);
            0;
            testswcbre(y,x,nc,epsilon2,epsilon2,family1,family2,betahatcbrep4(:,2*(i1-1)+1),betahatcbrep5(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon2,epsilon2,family1,family3,betahatcbrep4(:,2*(i1-1)+1),betahatcbrep6(:,2*(i1-1)+1),N1,N2,sizetest)];
    elseif bestaiccbrep(i1)==5
        [~,critindcbrep(:,i1),indtestcbrep(:,i1)]=testindcbre(family2,betahatcbrep5(:,2*(i1-1)+1),Htcbrep5(:,:,i1),sizetest);
        swtestcbrep(:,i1)=[testswcbre(y,x,nc,epsilon2,epsilon1,family2,family1,betahatcbrep5(:,2*(i1-1)+1),betahatcbrep1(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon2,epsilon1,family2,family2,betahatcbrep5(:,2*(i1-1)+1),betahatcbrep2(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon2,epsilon1,family2,family3,betahatcbrep5(:,2*(i1-1)+1),betahatcbrep3(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon2,epsilon2,family2,family1,betahatcbrep5(:,2*(i1-1)+1),betahatcbrep4(:,2*(i1-1)+1),N1,N2,sizetest);
            0;
            testswcbre(y,x,nc,epsilon2,epsilon2,family2,family3,betahatcbrep5(:,2*(i1-1)+1),betahatcbrep6(:,2*(i1-1)+1),N1,N2,sizetest)];
    elseif bestaiccbrep(i1)==6
        [~,critindcbrep(:,i1),indtestcbrep(:,i1)]=testindcbre(family3,betahatcbrep6(:,2*(i1-1)+1),Htcbrep6(:,:,i1),sizetest);
        swtestcbrep(:,i1)=[testswcbre(y,x,nc,epsilon2,epsilon1,family3,family1,betahatcbrep6(:,2*(i1-1)+1),betahatcbrep1(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon2,epsilon1,family3,family2,betahatcbrep6(:,2*(i1-1)+1),betahatcbrep2(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon2,epsilon1,family3,family3,betahatcbrep6(:,2*(i1-1)+1),betahatcbrep3(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon2,epsilon2,family3,family1,betahatcbrep6(:,2*(i1-1)+1),betahatcbrep4(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbre(y,x,nc,epsilon2,epsilon2,family3,family2,betahatcbrep6(:,2*(i1-1)+1),betahatcbrep5(:,2*(i1-1)+1),N1,N2,sizetest);
            0];
    end
    if bestaiccbcrep(i1)==1
        [~,critindcbcrep(:,i1),indtestcbcrep(:,i1)]=testindcbcre(family1,betahatcbcrep1(:,2*(i1-1)+1),Htcbcrep1(:,:,i1),sizetest);
        swtestcbcrep(:,i1)=[0;
            testswcbcre(y,x,xm,nc,epsilon1,epsilon1,family1,family2,betahatcbcrep1(:,2*(i1-1)+1),betahatcbcrep2(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon1,epsilon1,family1,family3,betahatcbcrep1(:,2*(i1-1)+1),betahatcbcrep3(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon1,epsilon2,family1,family1,betahatcbcrep1(:,2*(i1-1)+1),betahatcbcrep4(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon1,epsilon2,family1,family2,betahatcbcrep1(:,2*(i1-1)+1),betahatcbcrep5(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon1,epsilon2,family1,family3,betahatcbcrep1(:,2*(i1-1)+1),betahatcbcrep6(:,2*(i1-1)+1),N1,N2,sizetest)];
    elseif bestaiccbcrep(i1)==2
        [~,critindcbcrep(:,i1),indtestcbcrep(:,i1)]=testindcbcre(family2,betahatcbcrep2(:,2*(i1-1)+1),Htcbcrep2(:,:,i1),sizetest);
        swtestcbcrep(:,i1)=[testswcbcre(y,x,xm,nc,epsilon1,epsilon1,family2,family1,betahatcbcrep2(:,2*(i1-1)+1),betahatcbcrep1(:,2*(i1-1)+1),N1,N2,sizetest);
            0;
            testswcbcre(y,x,xm,nc,epsilon1,epsilon1,family2,family3,betahatcbcrep2(:,2*(i1-1)+1),betahatcbcrep3(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon1,epsilon2,family2,family1,betahatcbcrep2(:,2*(i1-1)+1),betahatcbcrep4(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon1,epsilon2,family2,family2,betahatcbcrep2(:,2*(i1-1)+1),betahatcbcrep5(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon1,epsilon2,family2,family3,betahatcbcrep2(:,2*(i1-1)+1),betahatcbcrep6(:,2*(i1-1)+1),N1,N2,sizetest)];
    elseif bestaiccbcrep(i1)==3
        [~,critindcbcrep(:,i1),indtestcbcrep(:,i1)]=testindcbcre(family3,betahatcbcrep3(:,2*(i1-1)+1),Htcbcrep3(:,:,i1),sizetest);
        swtestcbcrep(:,i1)=[testswcbcre(y,x,xm,nc,epsilon1,epsilon1,family3,family1,betahatcbcrep3(:,2*(i1-1)+1),betahatcbcrep1(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon1,epsilon1,family3,family2,betahatcbcrep3(:,2*(i1-1)+1),betahatcbcrep2(:,2*(i1-1)+1),N1,N2,sizetest);
            0;
            testswcbcre(y,x,xm,nc,epsilon1,epsilon2,family3,family1,betahatcbcrep3(:,2*(i1-1)+1),betahatcbcrep4(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon1,epsilon2,family3,family2,betahatcbcrep3(:,2*(i1-1)+1),betahatcbcrep5(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon1,epsilon2,family3,family3,betahatcbcrep3(:,2*(i1-1)+1),betahatcbcrep6(:,2*(i1-1)+1),N1,N2,sizetest)];
    elseif bestaiccbcrep(i1)==4
        [~,critindcbcrep(:,i1),indtestcbcrep(:,i1)]=testindcbcre(family1,betahatcbcrep4(:,2*(i1-1)+1),Htcbcrep4(:,:,i1),sizetest);
        swtestcbcrep(:,i1)=[testswcbcre(y,x,xm,nc,epsilon2,epsilon1,family1,family1,betahatcbcrep4(:,2*(i1-1)+1),betahatcbcrep1(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon2,epsilon1,family1,family2,betahatcbcrep4(:,2*(i1-1)+1),betahatcbcrep2(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon2,epsilon1,family1,family3,betahatcbcrep4(:,2*(i1-1)+1),betahatcbcrep3(:,2*(i1-1)+1),N1,N2,sizetest);
            0;
            testswcbcre(y,x,xm,nc,epsilon2,epsilon2,family1,family2,betahatcbcrep4(:,2*(i1-1)+1),betahatcbcrep5(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon2,epsilon2,family1,family3,betahatcbcrep4(:,2*(i1-1)+1),betahatcbcrep6(:,2*(i1-1)+1),N1,N2,sizetest)];
    elseif bestaiccbcrep(i1)==5
        [~,critindcbcrep(:,i1),indtestcbcrep(:,i1)]=testindcbcre(family2,betahatcbcrep5(:,2*(i1-1)+1),Htcbcrep5(:,:,i1),sizetest);
        swtestcbcrep(:,i1)=[testswcbcre(y,x,xm,nc,epsilon2,epsilon1,family2,family1,betahatcbcrep5(:,2*(i1-1)+1),betahatcbcrep1(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon2,epsilon1,family2,family2,betahatcbcrep5(:,2*(i1-1)+1),betahatcbcrep2(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon2,epsilon1,family2,family3,betahatcbcrep5(:,2*(i1-1)+1),betahatcbcrep3(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon2,epsilon2,family2,family1,betahatcbcrep5(:,2*(i1-1)+1),betahatcbcrep4(:,2*(i1-1)+1),N1,N2,sizetest);
            0;
            testswcbcre(y,x,xm,nc,epsilon2,epsilon2,family2,family3,betahatcbcrep5(:,2*(i1-1)+1),betahatcbcrep6(:,2*(i1-1)+1),N1,N2,sizetest)];
    elseif bestaiccbcrep(i1)==6
        [~,critindcbcrep(:,i1),indtestcbcrep(:,i1)]=testindcbcre(family3,betahatcbcrep6(:,2*(i1-1)+1),Htcbcrep6(:,:,i1),sizetest);
        swtestcbcrep(:,i1)=[testswcbcre(y,x,xm,nc,epsilon2,epsilon1,family3,family1,betahatcbcrep6(:,2*(i1-1)+1),betahatcbcrep1(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon2,epsilon1,family3,family2,betahatcbcrep6(:,2*(i1-1)+1),betahatcbcrep2(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon2,epsilon1,family3,family3,betahatcbcrep6(:,2*(i1-1)+1),betahatcbcrep3(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon2,epsilon2,family3,family1,betahatcbcrep6(:,2*(i1-1)+1),betahatcbcrep4(:,2*(i1-1)+1),N1,N2,sizetest);
            testswcbcre(y,x,xm,nc,epsilon2,epsilon2,family3,family2,betahatcbcrep6(:,2*(i1-1)+1),betahatcbcrep5(:,2*(i1-1)+1),N1,N2,sizetest);
            0];
    end
    
    if bestaiccbrep(i1)==1
        epsiloncbrep=epsilon1;
        familycbrep=family1;
        betacbrep=betahatcbrep1(:,2*(i1-1)+1);
        betahatcbrep(:,2*(i1-1)+1:2*i1)=betahatcbrep1(:,2*(i1-1)+1:2*i1);
        Hcbrep=Htcbrep1(:,:,i1);
    elseif bestaiccbrep(i1)==2
        epsiloncbrep=epsilon1;
        familycbrep=family2;
        betacbrep=betahatcbrep2(:,2*(i1-1)+1);
        betahatcbrep(:,2*(i1-1)+1:2*i1)=betahatcbrep2(:,2*(i1-1)+1:2*i1);
        Hcbrep=Htcbrep2(:,:,i1);
    elseif bestaiccbrep(i1)==3
        epsiloncbrep=epsilon1;
        familycbrep=family3;
        betacbrep=betahatcbrep3(:,2*(i1-1)+1);
        betahatcbrep(:,2*(i1-1)+1:2*i1)=betahatcbrep3(:,2*(i1-1)+1:2*i1);
        Hcbrep=Htcbrep3(:,:,i1);
    elseif bestaiccbrep(i1)==4
        epsiloncbrep=epsilon2;
        familycbrep=family1;
        betacbrep=betahatcbrep4(:,2*(i1-1)+1);
        betahatcbrep(:,2*(i1-1)+1:2*i1)=betahatcbrep4(:,2*(i1-1)+1:2*i1);
        Hcbrep=Htcbrep4(:,:,i1);
    elseif bestaiccbrep(i1)==5
        epsiloncbrep=epsilon2;
        familycbrep=family2;
        betacbrep=betahatcbrep5(:,2*(i1-1)+1);
        betahatcbrep(:,2*(i1-1)+1:2*i1)=betahatcbrep5(:,2*(i1-1)+1:2*i1);
        Hcbrep=Htcbrep5(:,:,i1);
    elseif bestaiccbrep(i1)==6
        epsiloncbrep=epsilon2;
        familycbrep=family3;
        betacbrep=betahatcbrep6(:,2*(i1-1)+1);
        betahatcbrep(:,2*(i1-1)+1:2*i1)=betahatcbrep6(:,2*(i1-1)+1:2*i1);
        Hcbrep=Htcbrep6(:,:,i1);
    end
    
    if bestaiccbcrep(i1)==1
        epsiloncbcrep=epsilon1;
        familycbcrep=family1;
        betacbcrep=betahatcbcrep1(:,2*(i1-1)+1);
        betahatcbcrep(:,2*(i1-1)+1:2*i1)=betahatcbcrep1(:,2*(i1-1)+1:2*i1);
        Hcbcrep=Htcbcrep1(:,:,i1);
    elseif bestaiccbcrep(i1)==2
        epsiloncbcrep=epsilon1;
        familycbcrep=family2;
        betacbcrep=betahatcbcrep2(:,2*(i1-1)+1);
        betahatcbcrep(:,2*(i1-1)+1:2*i1)=betahatcbcrep2(:,2*(i1-1)+1:2*i1);
        Hcbcrep=Htcbcrep2(:,:,i1);
    elseif bestaiccbcrep(i1)==3
        epsiloncbcrep=epsilon1;
        familycbcrep=family3;
        betacbcrep=betahatcbcrep3(:,2*(i1-1)+1);
        betahatcbcrep(:,2*(i1-1)+1:2*i1)=betahatcbcrep3(:,2*(i1-1)+1:2*i1);
        Hcbcrep=Htcbcrep3(:,:,i1);
    elseif bestaiccbcrep(i1)==4
        epsiloncbcrep=epsilon2;
        familycbcrep=family1;
        betacbcrep=betahatcbcrep4(:,2*(i1-1)+1);
        betahatcbcrep(:,2*(i1-1)+1:2*i1)=betahatcbcrep4(:,2*(i1-1)+1:2*i1);
        Hcbcrep=Htcbcrep4(:,:,i1);
    elseif bestaiccbcrep(i1)==5
        epsiloncbcrep=epsilon2;
        familycbcrep=family2;
        betacbcrep=betahatcbcrep5(:,2*(i1-1)+1);
        betahatcbcrep(:,2*(i1-1)+1:2*i1)=betahatcbcrep5(:,2*(i1-1)+1:2*i1);
        Hcbcrep=Htcbcrep5(:,:,i1);
    elseif bestaiccbcrep(i1)==6
        epsiloncbcrep=epsilon2;
        familycbcrep=family3;
        betacbcrep=betahatcbcrep6(:,2*(i1-1)+1);
        betahatcbcrep(:,2*(i1-1)+1:2*i1)=betahatcbcrep6(:,2*(i1-1)+1:2*i1);
        Hcbcrep=Htcbcrep6(:,:,i1);
    end
    
    if bestaiccbreb(i1)==1
        epsiloncbreb=epsilon1;
        betacbreb=betahatcbreb1(:,2*(i1-1)+1);
        betahatcbreb(:,2*(i1-1)+1:2*i1)=betahatcbreb1(:,2*(i1-1)+1:2*i1);
        alphacbreb=alphahatcbreb1(:,2*(i1-1)+1);
        alphahatcbreb(1:(dstarcbreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbreb1(:,2*(i1-1)+1:2*i1);
        Hcbreb=Htcbreb1(:,:,i1);
    elseif bestaiccbreb(i1)==2
        epsiloncbreb=epsilon1;
        betacbreb=betahatcbreb2(:,2*(i1-1)+1);
        betahatcbreb(:,2*(i1-1)+1:2*i1)=betahatcbreb2(:,2*(i1-1)+1:2*i1);
        alphacbreb=alphahatcbreb2(:,2*(i1-1)+1);
        alphahatcbreb(1:(dstarcbreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbreb2(:,2*(i1-1)+1:2*i1);
        Hcbreb=Htcbreb2(:,:,i1);
    elseif bestaiccbreb(i1)==3
        epsiloncbreb=epsilon1;
        betacbreb=betahatcbreb3(:,2*(i1-1)+1);
        betahatcbreb(:,2*(i1-1)+1:2*i1)=betahatcbreb3(:,2*(i1-1)+1:2*i1);
        alphacbreb=alphahatcbreb3(:,2*(i1-1)+1);
        alphahatcbreb(1:(dstarcbreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbreb3(:,2*(i1-1)+1:2*i1);
        Hcbreb=Htcbreb3(:,:,i1);
    elseif bestaiccbreb(i1)==4
        epsiloncbreb=epsilon2;
        betacbreb=betahatcbreb4(:,2*(i1-1)+1);
        betahatcbreb(:,2*(i1-1)+1:2*i1)=betahatcbreb4(:,2*(i1-1)+1:2*i1);
        alphacbreb=alphahatcbreb4(:,2*(i1-1)+1);
        alphahatcbreb(1:(dstarcbreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbreb4(:,2*(i1-1)+1:2*i1);
        Hcbreb=Htcbreb4(:,:,i1);
    elseif bestaiccbreb(i1)==5
        epsiloncbreb=epsilon2;
        betacbreb=betahatcbreb5(:,2*(i1-1)+1);
        betahatcbreb(:,2*(i1-1)+1:2*i1)=betahatcbreb5(:,2*(i1-1)+1:2*i1);
        alphacbreb=alphahatcbreb5(:,2*(i1-1)+1);
        alphahatcbreb(1:(dstarcbreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbreb5(:,2*(i1-1)+1:2*i1);
        Hcbreb=Htcbreb5(:,:,i1);
    elseif bestaiccbreb(i1)==6
        epsiloncbreb=epsilon2;
        betacbreb=betahatcbreb6(:,2*(i1-1)+1);
        betahatcbreb(:,2*(i1-1)+1:2*i1)=betahatcbreb6(:,2*(i1-1)+1:2*i1);
        alphacbreb=alphahatcbreb6(:,2*(i1-1)+1);
        alphahatcbreb(1:(dstarcbreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbreb6(:,2*(i1-1)+1:2*i1);
        Hcbreb=Htcbreb6(:,:,i1);
    end
    
    if bestaiccbcreb(i1)==1
        epsiloncbcreb=epsilon1;
        betacbcreb=betahatcbcreb1(:,2*(i1-1)+1);
        betahatcbcreb(:,2*(i1-1)+1:2*i1)=betahatcbcreb1(:,2*(i1-1)+1:2*i1);
        alphacbcreb=alphahatcbcreb1(:,2*(i1-1)+1);
        alphahatcbcreb(1:(dstarcbcreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbcreb1(:,2*(i1-1)+1:2*i1);
        Hcbcreb=Htcbcreb1(:,:,i1);
    elseif bestaiccbcreb(i1)==2
        epsiloncbcreb=epsilon1;
        betacbcreb=betahatcbcreb2(:,2*(i1-1)+1);
        betahatcbcreb(:,2*(i1-1)+1:2*i1)=betahatcbcreb2(:,2*(i1-1)+1:2*i1);
        alphacbcreb=alphahatcbcreb2(:,2*(i1-1)+1);
        alphahatcbcreb(1:(dstarcbcreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbcreb2(:,2*(i1-1)+1:2*i1);
        Hcbcreb=Htcbcreb2(:,:,i1);
    elseif bestaiccbcreb(i1)==3
        epsiloncbcreb=epsilon1;
        betacbcreb=betahatcbcreb3(:,2*(i1-1)+1);
        betahatcbcreb(:,2*(i1-1)+1:2*i1)=betahatcbcreb3(:,2*(i1-1)+1:2*i1);
        alphacbcreb=alphahatcbcreb3(:,2*(i1-1)+1);
        alphahatcbcreb(1:(dstarcbcreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbcreb3(:,2*(i1-1)+1:2*i1);
        Hcbcreb=Htcbcreb3(:,:,i1);
    elseif bestaiccbcreb(i1)==4
        epsiloncbcreb=epsilon2;
        betacbcreb=betahatcbcreb4(:,2*(i1-1)+1);
        betahatcbcreb(:,2*(i1-1)+1:2*i1)=betahatcbcreb4(:,2*(i1-1)+1:2*i1);
        alphacbcreb=alphahatcbcreb4(:,2*(i1-1)+1);
        alphahatcbcreb(1:(dstarcbcreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbcreb4(:,2*(i1-1)+1:2*i1);
        Hcbcreb=Htcbcreb4(:,:,i1);
    elseif bestaiccbcreb(i1)==5
        epsiloncbcreb=epsilon2;
        betacbcreb=betahatcbcreb5(:,2*(i1-1)+1);
        betahatcbcreb(:,2*(i1-1)+1:2*i1)=betahatcbcreb5(:,2*(i1-1)+1:2*i1);
        alphacbcreb=alphahatcbcreb5(:,2*(i1-1)+1);
        alphahatcbcreb(1:(dstarcbcreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbcreb5(:,2*(i1-1)+1:2*i1);
        Hcbcreb=Htcbcreb5(:,:,i1);
    elseif bestaiccbcreb(i1)==6
        epsiloncbcreb=epsilon2;
        betacbcreb=betahatcbcreb6(:,2*(i1-1)+1);
        betahatcbcreb(:,2*(i1-1)+1:2*i1)=betahatcbcreb6(:,2*(i1-1)+1:2*i1);
        alphacbcreb=alphahatcbcreb6(:,2*(i1-1)+1);
        alphahatcbcreb(1:(dstarcbcreb(i1)-1)^2,2*(i1-1)+1:2*i1)=alphahatcbcreb6(:,2*(i1-1)+1:2*i1);
        Hcbcreb=Htcbcreb6(:,:,i1);
    end
    
    %Compute Kendall's Tau statistic for the copula with the best fit
    kendallcbrep(i1)=copulastat(familycbrep,betacbrep(end));
    kendallcbcrep(i1)=copulastat(familycbcrep,betacbcrep(end));
    [C,c,~]=bernsteindens(alphacbreb,100);
    kendallcbreb(i1)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    [C,c,~]=bernsteindens(alphacbcreb,100);
    kendallcbcreb(i1)=4*sum(sum(C.*c))./(sum(sum(c)))-1;
    
    %Estimates of the joint and conditional probabilities of interest
    [pcbrep0,sepcbrep0]=probabilitywork_cbrep(y,x,nc,betacbrep,Hcbrep,epsiloncbrep,familycbrep,N1,N2);
    [pcbcrep0,sepcbcrep0]=probabilitywork_cbcrep(y,x,xm,nc,betacbcrep,Hcbcrep,epsiloncbcrep,familycbcrep,N1,N2);
    [pcbreb0,sepcbreb0]=probabilitywork_cbreb(y,x,nc,betacbreb,alphacbreb,Hcbreb,epsiloncbreb,N1,dstarcbreb(i1));
    [pcbcreb0,sepcbcreb0]=probabilitywork_cbcreb(y,x,xm,nc,betacbcreb,alphacbcreb,Hcbcreb,epsiloncbcreb,N1,dstarcbcreb(i1));
    
    ppcbrep(:,2*(i1-1)+1:2*i1)=100*[pcbrep0,sepcbrep0];
    ppcbcrep(:,2*(i1-1)+1:2*i1)=100*[pcbcrep0,sepcbcrep0];
    ppcbreb(:,2*(i1-1)+1:2*i1)=100*[pcbreb0,sepcbreb0];
    ppcbcreb(:,2*(i1-1)+1:2*i1)=100*[pcbcreb0,sepcbcreb0];
    
    n1=0;
    n0=0;
    for i2=1:1:N/2
        for i3=1:1:T
            if y(2*(i2-1)+1,i3)==1
                absprob(1,i1)=absprob(1,i1)+y(2*i2,i3);
                n1=n1+1;
            elseif y(2*(i2-1)+1,i3)==0
                absprob(2,i1)=absprob(2,i1)+y(2*i2,i3);
                n0=n0+1;
            end
        end
    end
    absprob(1,i1)=absprob(1,i1)/n1;
    absprob(2,i1)=absprob(2,i1)/n0;
    
    %Decomposition
    if strcmp(epsiloncbrep,epsilon1)==1
        [pcbrep1,sepcbrep1]=decomposition_cbrep(y,x,nc,betacbrep,Hcbrep,N1,N2,betahatre1(:,2*(i1-1)+1),Htre1(:,:,i1),R,epsiloncbrep,familycbrep);
    else
        [pcbrep1,sepcbrep1]=decomposition_cbrep(y,x,nc,betacbrep,Hcbrep,N1,N2,betahatre2(:,2*(i1-1)+1),Htre2(:,:,i1),R,epsiloncbrep,familycbrep);
    end
    pdeccbrep(:,2*(i1-1)+1:2*i1)=100*[pcbrep1,sepcbrep1];
    if strcmp(epsiloncbcrep,epsilon1)==1
        [pcbcrep1,sepcbcrep1]=decomposition_cbcrep(y,x,xm,nc,betacbcrep,Hcbcrep,N1,N2,betahatcre1(:,2*(i1-1)+1),Htcre1(:,:,i1),R,epsiloncbcrep,familycbcrep);
    else
        [pcbcrep1,sepcbcrep1]=decomposition_cbcrep(y,x,xm,nc,betacbcrep,Hcbcrep,N1,N2,betahatcre2(:,2*(i1-1)+1),Htcre2(:,:,i1),R,epsiloncbcrep,familycbcrep);
    end
    pdeccbcrep(:,2*(i1-1)+1:2*i1)=100*[pcbcrep1,sepcbcrep1];
    if strcmp(epsiloncbreb,epsilon1)==1
        [pcbreb1,sepcbreb1]=decomposition_cbreb(y,x,nc,betacbreb,alphacbreb,Hcbreb,N1,betahatre1(:,2*(i1-1)+1),Htre1(:,:,i1),R,epsiloncbreb,dstarcbreb(i1));
    else
        [pcbreb1,sepcbreb1]=decomposition_cbreb(y,x,nc,betacbreb,alphacbreb,Hcbreb,N1,betahatre2(:,2*(i1-1)+1),Htre2(:,:,i1),R,epsiloncbreb,dstarcbreb(i1));
    end
    pdeccbreb(:,2*(i1-1)+1:2*i1)=100*[pcbreb1,sepcbreb1];
    if strcmp(epsiloncbcreb,epsilon1)==1
        [pcbcreb1,sepcbcreb1]=decomposition_cbcreb(y,x,xm,nc,betacbcreb,alphacbcreb,Hcbcreb,N1,betahatcre1(:,2*(i1-1)+1),Htcre1(:,:,i1),R,epsiloncbcreb,dstarcbcreb(i1));
    else
        [pcbcreb1,sepcbcreb1]=decomposition_cbcreb(y,x,xm,nc,betacbcreb,alphacbcreb,Hcbcreb,N1,betahatcre2(:,2*(i1-1)+1),Htcre2(:,:,i1),R,epsiloncbcreb,dstarcbcreb(i1));
    end
    pdeccbcreb(:,2*(i1-1)+1:2*i1)=100*[pcbcreb1,sepcbcreb1];
end

tabledif=zeros(2*6,ncount);
tableparcbrep=zeros(2*(T+K+2)+4,ncount);
tableparcbcrep=zeros(2*(T+K+Kv+2)+4,ncount);
tableparcbreb=zeros(2*(T+K+1)+4,ncount);
tableparcbcreb=zeros(2*(T+K+Kv+1)+4,ncount);
tableparre=zeros(2*(T+K+1)+1,ncount);
tableparcre=zeros(2*(T+K+Kv+1)+1,ncount);
tabletp=[swtestcbcrep;zeros(19,ncount)];
tabletpb=zeros(19,ncount);
tabletpcre=zeros(7,ncount);
for i1=1:1:ncount
    tabledif(:,i1)=reshape(xdif(:,2*(i1-1)+1:2*i1)',1,12);
    tableparcbrep(1:2:2*(T+K+2)-1,i1)=betahatcbrep(:,2*(i1-1)+1);
    tableparcbrep(2:2:2*(T+K+1),i1)=betahatcbrep(1:end-1,2*(i1-1)+2);
    tableparcbrep(2*(T+K+2),i1)=indtestcbrep(i1);
    tableparcbcrep(1:2:2*(T+K+Kv+2)-1,i1)=betahatcbcrep(:,2*(i1-1)+1);
    tableparcbcrep(2:2:2*(T+K+Kv+1),i1)=betahatcbcrep(1:end-1,2*(i1-1)+2);
    tableparcbcrep(2*(T+K+Kv+2),i1)=indtestcbcrep(i1);
    tableparcbreb(1:2:2*(T+K+1)-1,i1)=betahatcbreb(:,2*(i1-1)+1);
    tableparcbreb(2:2:2*(T+K+1),i1)=betahatcbreb(:,2*i1);
    tableparcbcreb(1:2:2*(T+K+Kv+1)-1,i1)=betahatcbcreb(:,2*(i1-1)+1);
    tableparcbcreb(2:2:2*(T+K+Kv+1),i1)=betahatcbcreb(:,2*i1);
    if bestaiccbrep(i1)<=3
        tableparre(1:2:2*(T+K+1)-1,i1)=betahatre1(:,2*(i1-1)+1);
        tableparre(2:2:2*(T+K+1),i1)=betahatre1(:,2*(i1-1)+2);
    else
        tableparre(1:2:2*(T+K+1)-1,i1)=betahatre2(:,2*(i1-1)+1);
        tableparre(2:2:2*(T+K+1),i1)=betahatre2(:,2*(i1-1)+2);
    end
    if bestaiccbcrep(i1)<=3
        tableparcre(1:2:2*(T+K+Kv+1)-1,i1)=betahatcre1(:,2*(i1-1)+1);
        tableparcre(2:2:2*(T+K+Kv+1),i1)=betahatcre1(:,2*(i1-1)+2);
    else
        tableparcre(1:2:2*(T+K+Kv+1)-1,i1)=betahatcre2(:,2*(i1-1)+1);
        tableparcre(2:2:2*(T+K+Kv+1),i1)=betahatcre2(:,2*(i1-1)+2);
    end
    tabletp(7:12,i1)=reshape(ppcbcrep(:,2*(i1-1)+1:2*i1)',1,6)';
    tabletp(13:24,i1)=reshape(pdeccbcrep([1,3,4,7,8,9],2*(i1-1)+1:2*i1)',1,12)';
    tabletpb(1:6,i1)=reshape(ppcbcreb(:,2*(i1-1)+1:2*i1)',1,6)';
    tabletpb(7:18,i1)=reshape(pdeccbcreb([1,3,4,7,8,9],2*(i1-1)+1:2*i1)',1,12)';
    tabletpcre(:,i1)=reshape(pdeccbcrep([2,5,6],2*(i1-1)+1:2*i1)',1,6)';
end

for i1=1:1:ncount
    if bestaiccbrep(i1)==1
        tableparcbrep(2*(T+K+2)+1:end-1,i1)=[1;1;kendallcbrep(i1)];
    elseif bestaiccbrep(i1)==2
        tableparcbrep(2*(T+K+2)+1:end-1,i1)=[1;2;kendallcbrep(i1)];
    elseif bestaiccbrep(i1)==3
        tableparcbrep(2*(T+K+2)+1:end-1,i1)=[1;3;kendallcbrep(i1)];
    elseif bestaiccbrep(i1)==4
        tableparcbrep(2*(T+K+2)+1:end-1,i1)=[2;1;kendallcbrep(i1)];
    elseif bestaiccbrep(i1)==5
        tableparcbrep(2*(T+K+2)+1:end-1,i1)=[2;2;kendallcbrep(i1)];
    elseif bestaiccbrep(i1)==6
        tableparcbrep(2*(T+K+2)+1:end-1,i1)=[2;3;kendallcbrep(i1)];
    end
end

for i1=1:1:ncount
    if bestaiccbcrep(i1)==1
        tableparcbcrep(2*(T+K+Kv+2)+1:end-1,i1)=[1;1;kendallcbcrep(i1)];
    elseif bestaiccbcrep(i1)==2
        tableparcbcrep(2*(T+K+Kv+2)+1:end-1,i1)=[1;2;kendallcbcrep(i1)];
    elseif bestaiccbcrep(i1)==3
        tableparcbcrep(2*(T+K+Kv+2)+1:end-1,i1)=[1;3;kendallcbcrep(i1)];
    elseif bestaiccbcrep(i1)==4
        tableparcbcrep(2*(T+K+Kv+2)+1:end-1,i1)=[2;1;kendallcbcrep(i1)];
    elseif bestaiccbcrep(i1)==5
        tableparcbcrep(2*(T+K+Kv+2)+1:end-1,i1)=[2;2;kendallcbcrep(i1)];
    elseif bestaiccbcrep(i1)==6
        tableparcbcrep(2*(T+K+Kv+2)+1:end-1,i1)=[2;3;kendallcbcrep(i1)];
    end
end

for i1=1:1:ncount
    if bestaiccbreb(i1)==1
        tableparcbreb(2*(T+K+1)+1:end-1,i1)=[1;1;kendallcbreb(i1)];
    elseif bestaiccbreb(i1)==2
        tableparcbreb(2*(T+K+1)+1:end-1,i1)=[1;2;kendallcbreb(i1)];
    elseif bestaiccbreb(i1)==3
        tableparcbreb(2*(T+K+1)+1:end-1,i1)=[1;3;kendallcbreb(i1)];
    elseif bestaiccbreb(i1)==4
        tableparcbreb(2*(T+K+1)+1:end-1,i1)=[2;1;kendallcbreb(i1)];
    elseif bestaiccbreb(i1)==5
        tableparcbreb(2*(T+K+1)+1:end-1,i1)=[2;2;kendallcbreb(i1)];
    elseif bestaiccbreb(i1)==6
        tableparcbreb(2*(T+K+1)+1:end-1,i1)=[2;3;kendallcbreb(i1)];
    end
end

for i1=1:1:ncount
    if bestaiccbcreb(i1)==1
        tableparcbcreb(2*(T+K+Kv+1)+1:end-1,i1)=[1;1;kendallcbcreb(i1)];
    elseif bestaiccbcreb(i1)==2
        tableparcbcreb(2*(T+K+Kv+1)+1:end-1,i1)=[1;2;kendallcbcreb(i1)];
    elseif bestaiccbcreb(i1)==3
        tableparcbcreb(2*(T+K+Kv+1)+1:end-1,i1)=[1;3;kendallcbcreb(i1)];
    elseif bestaiccbcreb(i1)==4
        tableparcbcreb(2*(T+K+Kv+1)+1:end-1,i1)=[2;1;kendallcbcreb(i1)];
    elseif bestaiccbcreb(i1)==5
        tableparcbcreb(2*(T+K+Kv+1)+1:end-1,i1)=[2;2;kendallcbcreb(i1)];
    elseif bestaiccbcreb(i1)==6
        tableparcbcreb(2*(T+K+Kv+1)+1:end-1,i1)=[2;3;kendallcbcreb(i1)];
    end
end

tableparcbrep(end,:)=Ncount'/T;
tableparcbcrep(end,:)=Ncount'/T;
tableparcbreb(end,:)=Ncount'/T;
tableparcbcreb(end,:)=Ncount'/T;
tableparre(end,:)=Ncount'/T;
tableparcre(end,:)=Ncount'/T;
tabletp(end,:)=Ncount'/T;
tabletpb(end,:)=Ncount'/T;
tabletpcre(end,:)=Ncount'/T;

save estimationresults_final.mat xdif betahatre1 betahatre2 betahatcre1 betahatcre2...
    betahatcbrep betahatcbrep1 betahatcbrep2 betahatcbrep3 betahatcbrep4 betahatcbrep5 betahatcbrep6...
    betahatcbcrep betahatcbcrep1 betahatcbcrep2 betahatcbcrep3 betahatcbcrep4 betahatcbcrep5 betahatcbcrep6...
    betahatcbreb betahatcbreb1 betahatcbreb2 betahatcbreb3 betahatcbreb4 betahatcbreb5 betahatcbreb6...
    betahatcbcreb betahatcbcreb1 betahatcbcreb2 betahatcbcreb3 betahatcbcreb4 betahatcbcreb5 betahatcbcreb6...
    alphahatcbreb alphahatcbreb1 alphahatcbreb2 alphahatcbreb3 alphahatcbreb4 alphahatcbreb5 alphahatcbreb6...
    alphahatcbcreb alphahatcbcreb1 alphahatcbcreb2 alphahatcbcreb3 alphahatcbcreb4 alphahatcbcreb5 alphahatcbcreb6...
    Htre1 Htre2 Htcre1 Htcre2 Htcbrep1 Htcbrep2 Htcbrep3 Htcbrep4 Htcbrep5 Htcbrep6...
    Htcbcrep1 Htcbcrep2 Htcbcrep3 Htcbcrep4 Htcbcrep5 Htcbcrep6 Htcbreb1 Htcbreb2 Htcbreb3...
    Htcbreb4 Htcbreb5 Htcbreb6 Htcbcreb1 Htcbcreb2 Htcbcreb3 Htcbcreb4 Htcbcreb5 Htcbcreb6...
    ll aic bic cv bestll bestaic bestbic bestcvll bestaicre bestaiccbrep bestaiccbreb bestaiccre bestaiccbcrep bestaiccbcreb...
    dstarcbreb dstarcbcreb kendallcbrep kendallcbcrep kendallcbreb kendallcbcreb...
    critindcbrep indtestcbrep swtestcbrep critindcbcrep indtestcbcrep swtestcbcrep...
    ppcbrep ppcbcrep ppcbreb ppcbcreb absprob pdeccbrep pdeccbcrep pdeccbreb pdeccbcreb...
    tabledif tableparcbrep tableparcbcrep tableparcbreb tableparcbcreb tableparre tableparcre tabletp tabletpb tabletpcre



%Figures
figure1=1;
figure2=1;
figure3=1;
sc=[1,2,3,5,6,8,9,10,11,12,14,19,20,21,22,24];%Select countries to show
cop=zeros(1,length(sc));
rhocop=zeros(1,length(sc));
for i1=1:1:length(sc)
    cop(i1)=tableparcbcrep(end-2,sc(i1));
    rhocop(i1)=tableparcbcrep(2*(T+K+Kv+1)+1,sc(i1));
end

steps=99;
grid=linspace(1/(steps+1),steps/(steps+1),steps+1);
% steps=101;

if figure1==1
    fig1=figure(1);
    subplot(2,8,1)
    if cop(1)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(1));
            end
        end
    elseif cop(1)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(1));
            end
        end
    elseif cop(1)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(1));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('AT','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,2)
    if cop(2)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(2));
            end
        end
    elseif cop(2)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(2));
            end
        end
    elseif cop(2)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(2));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('BE','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,3)
    if cop(3)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(3));
            end
        end
    elseif cop(3)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(3));
            end
        end
    elseif cop(3)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(3));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('BG','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,4)
    if cop(4)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(4));
            end
        end
    elseif cop(4)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(4));
            end
        end
    elseif cop(4)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(4));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('CZ','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,5)
    if cop(5)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(5));
            end
        end
    elseif cop(5)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(5));
            end
        end
    elseif cop(5)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(5));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('DK','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,6)
    if cop(6)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(6));
            end
        end
    elseif cop(6)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(6));
            end
        end
    elseif cop(6)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(6));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('EL','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,7)
    if cop(7)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(7));
            end
        end
    elseif cop(7)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(7));
            end
        end
    elseif cop(7)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(7));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('ES','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,8)
    if cop(8)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(8));
            end
        end
    elseif cop(8)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(8));
            end
        end
    elseif cop(8)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(8));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('FI','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,9)
    if cop(9)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(9));
            end
        end
    elseif cop(9)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(9));
            end
        end
    elseif cop(9)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(9));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('FR','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,10)
    if cop(10)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(10));
            end
        end
    elseif cop(10)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(10));
            end
        end
    elseif cop(10)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(10));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('HU','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,11)
    if cop(11)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(11));
            end
        end
    elseif cop(11)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(11));
            end
        end
    elseif cop(11)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(11));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('IT','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,12)
    if cop(12)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(12));
            end
        end
    elseif cop(12)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(12));
            end
        end
    elseif cop(12)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(12));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('NL','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,13)
    if cop(13)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(13));
            end
        end
    elseif cop(13)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(13));
            end
        end
    elseif cop(13)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(13));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('NO','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,14)
    if cop(14)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(14));
            end
        end
    elseif cop(14)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(14));
            end
        end
    elseif cop(14)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(14));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('PL','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,15)
    if cop(15)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(15));
            end
        end
    elseif cop(15)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(15));
            end
        end
    elseif cop(15)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(15));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('PT','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,16)
    if cop(16)==1
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Clayton',[grid(i1),grid(i2)],rhocop(16));
            end
        end
    elseif cop(16)==2
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Frank',[grid(i1),grid(i2)],rhocop(16));
            end
        end
    elseif cop(16)==3
        pdf=zeros(steps+1);
        for i1=1:1:length(grid)
            for i2=1:1:length(grid)
                pdf(i1,i2)=copulapdf('Gaussian',[grid(i1),grid(i2)],rhocop(16));
            end
        end
    end
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('UK','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
%     xlim([0,1])
%     ylim([0,1])
%     xlabel('$\tau$','interpreter','latex','fontsize',12)
%     set(gca,'Position',[.13 .11 .1566 .77])
    set(fig1, 'PaperPosition', [1 1 18 10])
    print -depsc2 contours.eps
end

steps=101;
if figure2==1
    fig2=figure(2);
    subplot(2,8,1);
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(1))-1)^2,2*sc(1)-1),dstarcbcreb(sc(1)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('AT','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,2)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(2))-1)^2,2*sc(2)-1),dstarcbcreb(sc(2)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('BE','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,3)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(3))-1)^2,2*sc(3)-1),dstarcbcreb(sc(3)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('BG','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,4)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(4))-1)^2,2*sc(4)-1),dstarcbcreb(sc(4)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('CZ','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,5)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(5))-1)^2,2*sc(5)-1),dstarcbcreb(sc(5)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('DK','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,6)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(6))-1)^2,2*sc(6)-1),dstarcbcreb(sc(6)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('EL','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,7)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(7))-1)^2,2*sc(7)-1),dstarcbcreb(sc(7)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('ES','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,8)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(8))-1)^2,2*sc(8)-1),dstarcbcreb(sc(8)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('FI','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,9)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(9))-1)^2,2*sc(9)-1),dstarcbcreb(sc(9)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('FR','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,10)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(10))-1)^2,2*sc(10)-1),dstarcbcreb(sc(10)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('HU','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,11)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(11))-1)^2,2*sc(12)-1),dstarcbcreb(sc(11)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('IT','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,12)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(12))-1)^2,2*sc(12)-1),dstarcbcreb(sc(12)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('NL','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,13)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(13))-1)^2,2*sc(13)-1),dstarcbcreb(sc(13)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('NO','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,14)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(14))-1)^2,2*sc(14)-1),dstarcbcreb(sc(14)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('PL','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,15)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(15))-1)^2,2*sc(15)-1),dstarcbcreb(sc(15)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('PT','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    subplot(2,8,16)
    [pdf,grid]=bernsteinpdf(alphahatcbcreb(1:(dstarcbcreb(sc(16))-1)^2,2*sc(16)-1),dstarcbcreb(sc(16)),steps);
    contour(grid,grid,pdf,'LevelList',[.3,.6,.9,1.2,1.5,1.8,2.1,2.4,2.7,3])
    title('UK','FontSize',7.5)
    set(gca, 'XTick', [.5], 'FontSize',7.5);
    set(gca, 'YTick', [.2 .4 .6 .8], 'FontSize',7.5);
    set(fig2, 'PaperPosition', [1 1 18 10])
    print -depsc2 contoursbern.eps
end

if figure3==1
    fig3=figure(3);
    subplot(2,1,1)
    plot(linspace(1,length(sc),length(sc)),100*absprob(1,sc),'Marker','.','MarkerSize',15,'LineStyle','none','Color',[0 0 1],'DisplayName','P1');
    hold on;
    errorbar(linspace(1,length(sc),length(sc)),pdeccbcrep(3,2*sc-1),1.96*pdeccbcrep(3,2*sc),'Marker','x','LineStyle','none','Color',[0 .5 0],'DisplayName','$\hat{P1}_{CBRE}$');
    hold on;
    errorbar(linspace(1,length(sc),length(sc)),pdeccbcreb(3,2*sc-1),1.96*pdeccbcreb(3,2*sc),'Marker','diamond','LineStyle','none','Color',[0 0.75 0.75],'DisplayName','$\hat{P1}_{BERN}$');
    hold on;
    errorbar(linspace(1,length(sc),length(sc)),pdeccbcrep(5,2*sc-1),1.96*pdeccbcrep(5,2*sc),'Marker','o','LineStyle','none','Color',[1 0 0],'DisplayName','$\hat{P1}_{RE}$');
    legend3=legend('Location','eastoutside');
    set(legend3,'interpreter','latex','fontsize',7)
    xlim([0,length(sc)+1])
    ylim([40,100])
    ylabel('Employed husband');
    set(gca, 'XTickLabel', {'', 'AT','BE','BG','CZ','DK','EL','ES','FI','FR','HU','IT','NL','NO','PL','PT','UK', ''})
    set(gca, 'XTick', [0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17]);
    plot([0 length(sc)+1],[0,0],'Color',[0 0 0])
    subplot(2,1,2)
    plot(linspace(1,length(sc),length(sc)),100*absprob(2,sc),'Marker','.','MarkerSize',15,'LineStyle','none','Color',[0 0 1],'DisplayName','P0');
    hold on;
    errorbar(linspace(1,length(sc),length(sc)),pdeccbcrep(4,2*sc-1),1.96*pdeccbcrep(4,2*sc),'Marker','x','LineStyle','none','Color',[0 .5 0],'DisplayName','$\hat{P0}_{CBRE}$');
    hold on;
    errorbar(linspace(1,length(sc),length(sc)),pdeccbcreb(4,2*sc-1),1.96*pdeccbcreb(4,2*sc),'Marker','diamond','LineStyle','none','Color',[0 0.75 0.75],'DisplayName','$\hat{P0}_{BERN}$');
    hold on;
    errorbar(linspace(1,length(sc),length(sc)),pdeccbcrep(6,2*sc-1),1.96*pdeccbcrep(6,2*sc),'Marker','o','LineStyle','none','Color',[1 0 0],'DisplayName','$\hat{P0}_{RE}$');
    legend3=legend('Location','eastoutside');
    set(legend3,'interpreter','latex','fontsize',7)
    xlim([0,length(sc)+1])
    ylim([10,90])
    ylabel('Unemployed husband');
    set(gca, 'XTickLabel', {'', 'AT','BE','BG','CZ','DK','EL','ES','FI','FR','HU','IT','NL','NO','PL','PT','UK', ''})
    set(gca, 'XTick', [0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17]);
    plot([0 length(sc)+1],[0,0],'Color',[0 0 0])
    set(gcf, 'PaperPosition', [1 1 20 12]);
    print -depsc2 decomposition.eps
end