clear
clc

d=2;%copula dimension
rho=4;%copula correlation parameter
N1=[1,3,7];%number of grid points used in approximation
N2=[1,3,7];%number of grid points used in approximation

for i1=1:1:length(N1)
    gridgamma=linspace(1/(N1(i1)+1),N1(i1)/(N1(i1)+1),N1(i1));
    gridgamma=gaminv(gridgamma,1/rho,1);
    for i2=1:1:length(N2)
        grid=linspace(1/(N2(i2)+1),N2(i2)/(N2(i2)+1),N2(i2));

        uv0=zeros(N1(i1),N2(i2));
        for i3=1:1:N1(i1)
            uv0(i3,:)=(1-log(grid)/gridgamma(i3)).^(-1/rho);
        end
        uv1=zeros(N1(i1)*N2(i2)^2,2);
        uv1(:,1)=kron(reshape(uv0',N1(i1)*N2(i2),1),ones(N2(i2),1));
        for i3=1:1:N1(i1)
            uv1((i3-1)*N2(i2)^2+1:i3*N2(i2)^2,2)=kron(ones(N2(i2),1),uv0(i3,:)');
        end
        
        figure(1)
        subplot(3,3,3*(i1-1)+i2)
        scatter(uv1(:,1),uv1(:,2),'Marker','.')
        xlim([0,1])
        ylim([0,1])
        hold on;
    end
end

subplot(3,3,1)
ylabel('$N_1=1$','fontsize',12,'interpreter','Latex')
subplot(3,3,4)
ylabel('$N_1=3$','fontsize',12,'interpreter','Latex')
subplot(3,3,7)
ylabel('$N_1=7$','fontsize',12,'interpreter','Latex')
xlabel('$N_2=1$','fontsize',12,'interpreter','Latex')
subplot(3,3,8)
xlabel('$N_2=3$','fontsize',12,'interpreter','Latex')
subplot(3,3,9)
xlabel('$N_2=7$','fontsize',12,'interpreter','Latex')
set(gcf, 'PaperPosition', [1 1 20 8]);
print -depsc2 example1_fig1.eps