clear
clc

d=[2,3];%copula dimension
rho=4;%correlation coefficient
N1=[9,19,49,99];%approximation grid points
N2=N1;%approximation grid points
R=100;%number of repetitions


for i4=1:1:length(d)
    int1=zeros(R,length(N1));
    int2=zeros(R,length(N1));
    time1=zeros(R,length(N1));
    time2=zeros(R,length(N1));
    for i0=1:1:R
        for i1=1:1:length(N1)
            gridgamma=linspace(1/(N1(i1)+1),N1(i1)/(N1(i1)+1),N1(i1));
            gridgamma=gaminv(gridgamma,1/rho,1);
            grid=linspace(1/(N2(i1)+1),N2(i1)/(N2(i1)+1),N2(i1));
            
            %integral with the algorithm
            tic
            eta1=zeros(N1(i1),N2(i1));
            for i2=1:1:N1(i1)
                eta1(i2,:)=(1-log(grid)/gridgamma(i2)).^(-1/rho);
            end

            integral1=zeros(N1(i1),1);
            for i2=1:1:N1(i1)
                integral1(i2,1)=mean(eta1(i2,:).^.5)^d(i4);
            end
            int1(i0,i1)=mean(integral1);
            time1(i0,i1)=toc;
            
            %integral with Monte Carlo
            tic
            eta2=mvcoprnd('clayton',rho,N1(i1)*N2(i1)^d(i4),d(i4));

            int2(i0,i1)=mean(prod(eta2.^.5,2));
            time2(i0,i1)=toc;
        end
    end

    mtime=[mean(time1,1);mean(time2,1)];
    mint=[mean(int1,1);mean(int2,1)];
    sdint=[std(int1,1);std(int2,1)];
    
    if i4==1
        save montecarlo1_1.mat mtime mint sdint
    elseif  i4==2
        save montecarlo1_2.mat mtime mint sdint
    end
end